#ifndef HEADER_GAMEGRID
#define HEADER_GAMEGRID

#include<iostream>
/*
Gre la grille "mtier" du jeu
Cette classe ne contient aucunes instructions Qt afin de sparer la couche mtier de la vue et du controleur, et ainsi pouvoir faire un portage facile et rapide sur d'autre librairie graphique
*/
class GameGrid
{
    private:
		int initGrid[9][9];//Grille initiale contenant uniquement les chiffres fixes
		int currentGrid[9][9];//Grille courante contenant les chiffres fixes et ajouts par le joueur
		int solvedGrid[9][9];//La grille rsolue
		
		int hintX;//coordonnes des indices 
		int hintY;
	
		int RG;//rang de la grille (Permettra de faire des sudokus de tailles diffrentes)
		std::string name;//Nom de la grille qui sert aussi pour la sauvegarde
              
    public:
        GameGrid();
	
        int getGridElement(int row, int col);	
		bool gridElementIsOk(int row, int col);
		bool testIsOk(int row, int col);
		bool isFixed(int row, int col);
		bool solveGrid();
		void solve();
		
		bool checkGrid();		
		void saveGrid(std::string path);
		bool loadGrid(std::string path);
		void setNewValue(int row, int col, int value);   
		void clearGrid();
		void cleanGrid();
		void randomGrid(int difficulty);
		int fillRandomItem();
		bool hasName();
		int getHintX();
		int getHintY();
		bool isFull();
		std::string getName();
		
};
#endif
