#include "GridNum.h"
/*
Constructeur
	Initialise  vide la case, la connecte aux signaux, et dfinit son style (font et taille)
@param rowNum
	Numro de ligne de la case
@param colNum
	Numro de colonne de la case
*/
GridNum::GridNum(int rowNum, int colNum)
{	

	row=rowNum;
	col=colNum;
	value=0;					
	setStyleSheet("background:none;");
	setFixedWidth(50);
	setFixedHeight(50);
	setFlat(true);
	setFont(QFont("Comic Sans MS", 12));
	setEnabled(true);
	
	connect(this, SIGNAL(leftClicked()),this,SLOT(leftClickAction()));
	connect(this, SIGNAL(rightClicked()),this,SLOT(rightClickAction()));
	connect(this, SIGNAL(midClicked()),this,SLOT(midClickAction()));
}
/*
Modifieur
	Modifie la valeur de la case en vrifiant que la nouvelle est dans l'intervalle 0-9
@param newValue
	La nouvelle valeur de la case
*/
void GridNum::setValue(int newValue)
{
	value=newValue;
	if(value>9)
		value=0;
	else if(value<0)
		value=9;

	if(value)
		setText(QString().setNum(value));	
	else
		setText(QString());
}
/*
Rinitialise le bouton avec ses valeurs de dpart : taille, font, valeur, style
*/
void GridNum::newButton()
{
	value=0;					
	setStyleSheet("background:none;");
	setFixedWidth(50);
	setFixedHeight(50);
	setFlat(true);
	setFont(QFont("Comic Sans MS", 12));
	setEnabled(true);
}

//SLOTS
/*
Interdit la mise  jour graphique du bouton quand celui ci est cliqu afin d'viter de le voir s'enfoncer (peu esthtique)
*/
void GridNum::mousePressEvent(QMouseEvent *event)
{
	setUpdatesEnabled(false);
	QPushButton::mousePressEvent(event);		
}
/*
Ractive la mise  jour graphique du bouton pour permettre le changement de valeur...
Envois le bon signal en fonction du clic : gauche, droit, central
*/
void GridNum::mouseReleaseEvent(QMouseEvent *event)
{	
	QPushButton::mouseReleaseEvent(event);
	setUpdatesEnabled(true);
	
	if(event->button()==Qt::LeftButton)
		emit(leftClicked());
	else if(event->button()==Qt::RightButton)
		emit(rightClicked());
	else if(event->button()==Qt::MidButton)
		emit(midClicked());
	else
		emit(leftClicked());
}
/*
Appel quand clic gauche
Incrmente la valeur de la case
Emet un signal pour la mise  jour de la grille "mtier"
*/
void GridNum::leftClickAction()
{
	value++;	
	setValue(value);			
	emit buttonChanged(row,col,value);
}
/*
Appel quand clic droit
Dcrmente la valeur de la case
Emet un signal pour la mise  jour de la grille "mtier"
*/
void GridNum::rightClickAction()
{	
	value--;	
	setValue(value);			
	emit buttonChanged(row,col,value);
}
/*
Appel quand clic central
Efface la case (valeur = 0)
Emet un signal pour la mise  jour de la grille "mtier"
*/
void GridNum::midClickAction()
{
	value=0;
	setValue(value);			
	emit buttonChanged(row,col,value);
}