#include "GridView.h"
/*
Constructeur
	Initialise la vue de la grille : taille, cases
*/
GridView::GridView()
{                   
    gameGrid=new GameGrid();
   
    QGridLayout *gridLayout=new QGridLayout();
	gridLayout->setHorizontalSpacing(10);
	gridLayout->setVerticalSpacing(10);
	
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {                                                             
            gridButton[i][j]=new GridNum(i,j);
			
			connect(gridButton[i][j],SIGNAL(buttonChanged(int,int,int)),this,SLOT(changeGridValue(int,int,int)));
			
            gridLayout->addWidget(gridButton[i][j],i,j);
        }
    }
    this->setMinimumSize(402,402);
    this->setMaximumSize(402,402);	
	
	this->setLayout(gridLayout);
}
/*
Accesseur
@return pointeur vers la grille "mtier"
*/
GameGrid *GridView::getGameGrid()
{
	return gameGrid;
}
/*
Rafraichit la vue de la grille en mettant  jour les cases (GridNum)  partir de la grille "mtier"
*/
void GridView::refreshGridView()
{
	for(int i=0;i<9;i++)
		for(int j=0;j<9;j++)
		{
			
			if(gameGrid->isFixed(i,j))
			{				
				gridButton[i][j]->setValue(gameGrid->getGridElement(i,j));
				gridButton[i][j]->setFont(QFont("Comic Sans MS", 12));		
				gridButton[i][j]->setStyleSheet("color:black;background:none;");
				gridButton[i][j]->setEnabled(false);
			}
			else if(gameGrid->getGridElement(i,j))
			{
				gridButton[i][j]->setValue(gameGrid->getGridElement(i,j));
				gridButton[i][j]->setFont(QFont("Comic Sans MS", 12));
				gridButton[i][j]->setStyleSheet("color:blue;background:none;");
				gridButton[i][j]->setEnabled(true);
			}
			else
			{
				gridButton[i][j]->setValue(0);
				setEnabled(true);
				gridButton[i][j]->setFont(QFont("Comic Sans MS", 12));
			}				
		}
}
/*
Nettoie la vue de la grille en rinitialisant toutes les cases
*/
void GridView::newButtonGrid()
{
	for(int i=0;i<9;i++)
		for(int j=0;j<9;j++)
			gridButton[i][j]->newButton();
}

/*
Nettoie/vide la grille "mtier"
*/
void GridView::clearGrid()
{
	gameGrid->clearGrid();
	refreshGridView();			
}

/*
Met en surbrillance rouge la case incorrecte (trouve grce  la fonction "indice")
*/
void GridView::showWrongItem()
{
	int x=gameGrid->getHintX();
	int y=gameGrid->getHintY();
	gridButton[x][y]->setStyleSheet("color:red;background:none;");
}
/*
Met en surbrillance verte la case bonus (trouve grce  la fonction "indice")
*/
void GridView::showItemAdded()
{
	int x=gameGrid->getHintX();
	int y=gameGrid->getHintY();
	gridButton[x][y]->setStyleSheet("color:green;background:none;");
}
/*
Met  jour le background de la grille (lors d'un changement de thme)
@param gridBackground
	Le chemin vers le nouveua background
*/
void GridView::setNewGridBackground(QString gridBackground)
{
	this->setStyleSheet(QString("background-image:url(").append(gridBackground).append(");"));
}

//SLOTS
/*
Modifie la valeur d'une case de la grille
@param row
	La ligne de la case
@param col
	La colonne de la case
@param
	La nouvelle valeur de la case
*/
void GridView::changeGridValue(int row, int col, int value)
{
	gameGrid->setNewValue(row, col,value);
	refreshGridView();	
}
